﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using BR.AN.PviServices;
using System.Windows.Forms;
using System.Collections;


namespace ConsoleApplication2
{
    class Program
    {
        static Service service;
        static Cpu cpu;
        static Variable variable;
        [STAThread]
        static void Main(string[] args)
        {

            Console.WriteLine("Connecting Service ...");
            service = new Service("Service");
            service.Error += new PviEventHandler(Error);
            service.Connected += new PviEventHandler(service_Connected);
            service.Connect();

            // Message loop
            Application.Run();
        }
        static void service_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Service Connected Error=" + e.ErrorCode.ToString());
            cpu = new Cpu(service, "Cpu");
            cpu.Connection.DeviceType = DeviceType.ANSLTcp;
            cpu.Connection.ANSLTcp.DestinationIpAddress = "127.0.0.1";
            //cpu.Connection.TcpIp.DestinationStation = 1;
            //cpu.Connection.TcpIp.SourceStation = 100;
            //cpu.Connection.TcpIp.DestinationPort = 11159;
            //cpu.Connection.TcpIp.ResponseTimeout = 2000;
            cpu.Connected += new PviEventHandler(cpu_Connected);
            Console.WriteLine("Connecting Cpu ...");
            cpu.Connect();
        }

        static void cpu_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Cpu Connected Error=" + e.ErrorCode.ToString());
            variable = new Variable(cpu, "gData");
            variable.Active = true;
            variable.RefreshTime = 1;
            variable.Polling = false;
            variable.ValueChanged += new VariableEventHandler(ValueChanged);
            variable.Connected += new PviEventHandler(variable_Connected);
            Console.WriteLine("Connecting Variable ...");
            variable.Connect();
        }

        static void variable_Connected(object sender, PviEventArgs e)
        {
            Console.WriteLine("Variable Connected Error=" + e.ErrorCode.ToString());
        }

        /// <summary>
        /// Exit application if an error occurs
        /// </summary>
        static void Error(object sender, PviEventArgs e)
        {
            Console.WriteLine(String.Format("Error:{0}", e.ErrorText));
            //Application.Exit();
        }

        /// <summary>
        /// Write variable value to the console
        /// </summary>
        static void ValueChanged(object sender, VariableEventArgs e)
        {
            Variable var = (Variable)sender;

            Console.WriteLine("");
            //可以输出结构体的字符串信息，会按照一定顺序排布。
            Console.WriteLine("-----------获取整体结构体-----------");
            Console.WriteLine(DateTime.Now.ToString("yyyy - MM - dd hh: mm:ss.fff") + ": " + "Value={0}", var.Value.ToString());
            //Value均是以Hash表的方式存储，需要通过Key获取数值
            Console.WriteLine("-----------通过key值获取Value-----------");
            Console.WriteLine("Single Data a:" + "Value={0}", var.Value["a"].ToString());

            //将输出的字符串分割
            string phrase = var.Value.ToString();
            string[] words = phrase.Split(';');

            //单独显示
            Console.WriteLine("-----------单独显示-----------");
            Console.WriteLine("a: " + "{0}", words[0]);
            Console.WriteLine("b: " + "{0}", words[1]);
            Console.WriteLine("c: " + "{0}", words[2]);

            //遍历
            Console.WriteLine("-----------遍历显示-----------");
            foreach (var word in words)
            {
                System.Console.WriteLine($"{word}");
            }
        }
    }
}
